import "Turbine.UI";
import "Turbine.Gameplay"; -- this will expose the label control that we will implement
import "Turbine.UI.Lotro"; -- this will expose the standard window that we will implement
print=Turbine.Shell.WriteLine 
import "ChatPlus.dictionary";
import "ChatPlus.names";
import "ChatPlus.languages";

import "ChatPlus.codes";
import "ChatPlus.optionsmenu";

--0x410da93b
--0x4110a132
--0x4113f539
--0x4113f4f7
--0x4101e50c


vis=true

inDict = function(name)
	local found=false
	name=tostring(name)
	for i in pairs(dictionary) do
		if dictionary[i]~= nil and data["Allowed"][string.lower(dictionary[i])]~= true then
		if string.find(string.lower(name),string.lower(dictionary[i])) ~= nil and string.len(dictionary[i]) >= tonumber(data["Options"]["minimumLetters"]) then
			found=true
		end
		end
	end
	for i in pairs(data["Allowed"]) do
		if data["Allowed"][i]== false and string.find(string.lower(name),string.lower(i)) then
		found=true
		end
	end

	if data["Allowed"][string.lower(name)] then
		found=false
	end
	return found
end	


randomName = function(args)
	local name=nil
	taken=True
	local tries=0
	while name==nil or taken and tries <100 do
		tries = tries +1
		name=names
		expected={"race","origin","gender"}
		while type(name) ~= "string" do
			keys={}
			for i in pairs(name) do
				if i ~= "bree"then
					table.insert(keys,i)
				end
			end
			rand=keys[math.random(#keys)]
			potentialname=name[rand]
			for i in pairs(expected) do
				if name[args[expected[i]]] ~= nil then
					potentialname=name[args[expected[i]]]
				end
			end
			if name[1] ~= nil and type(name[1]) ~= "string" then
				prevname=name
			end
			name=potentialname
		
		end
		--Turbine.Shell.WriteLine(prevname[1])
		keys={}
		for i in pairs(prevname[1]) do
			table.insert(keys,i)
		end
		rand=keys[math.random(#keys)]
		firstpart=prevname[1][rand]
		keys={}
		for i in pairs(prevname[2]) do
			table.insert(keys,i)
		end
		rand=keys[math.random(#keys)]
		seccondpart=prevname[2][rand]
		taken=false
		for i in pairs(data["Replacements"]) do
			if data["Replacements"][i] == firstpart..seccondpart then
				taken=true
			end
		end
	end

	if tries >= 100 then
		return "Unable to Rename"
	else
		return firstpart..seccondpart
	end
end


			




----------------------load data----------------------------


dataLoadCompleteEventHandler = function(loadedData)
	data=loadedData
end

function load()
	data=Turbine.PluginData.Load(Turbine.DataScope.Character, "ChatPlusData",dataLoadCompleteEventHandler);
end
--see if data exists
--load()
if not pcall(load) then
	Turbine.Shell.WriteLine(strings["Unable to load data"][lang])
	data=defaultData
	Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
	print("<rgb=0x00FFE6>"..strings["help"][lang].." </rgb>")
elseif data==nil then
	Turbine.Shell.WriteLine(strings["Unable to load data"][lang])
	data=defaultData
	Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
	print("<rgb=0x00FFE6>"..strings["help"][lang].." </rgb>")
end

	
selectedOptionsHeading=1
populateOptionsHeadings()
optionChanged()

--------------------------------------------UI----------


clearwishlist=function()
	HelloWindoww.Message:SetText("");
	wlmsg=""
end
   
HelloWindoww=Turbine.UI.Window(); -- we call the constructor of the standard window object to create an instance
HelloWindoww:SetSize(1000,500); -- sets the window size to 200 by 200 pixels
HelloWindoww:SetPosition(Turbine.UI.Display:GetWidth()/2-500,10); -- centers the window in the display
HelloWindoww:SetText(strings["wishlist"][lang]); -- assigns the title bar text
--HelloWindoww:SetMouseVisible(false); 
--HelloWindow=Turbine.UI.Window();
--HelloWindow:SetParent(HelloWindoww);
--HelloWindow:SetSize(400,450); -- sets the window size to 200 by 200 pixels
--HelloWindow:SetPosition(Turbine.UI.Display:GetWidth()/2-100,50); -- centers the window in the display
--HelloWindow:SetText("PocketLM"); -- assigns the title bar text
HelloWindoww.Message=Turbine.UI.Label(); -- create a label control to display our message
HelloWindoww.Message:SetParent(HelloWindoww); -- sets the label as a child of the main window
HelloWindoww.Message:SetSize(1000,500); -- sets the message size
HelloWindoww.Message:SetPosition(10,-1); -- places the message control in the vertical middle of the window with a 10 pixel left and right border
HelloWindoww.Message:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter); -- centers the text in the message control both horizontally and vertically
HelloWindoww.Message:SetText("");
HelloWindoww:SetMouseVisible(false);

HelloWindoww.Message:SetFont(  Turbine.UI.Lotro.Font.TrajanProBold36);
HelloWindoww.Message:SetMarkupEnabled(true); 
--HelloWindoww.Button=Turbine.UI.Lotro.Button(); -- create a label control to display our message
--HelloWindoww.Button:SetParent(HelloWindoww); -- sets the label as a child of the main window
--HelloWindoww.Button:SetText(strings["clear"][lang]); -- sets the actual message text
--HelloWindoww.Button:SetPosition(140,450); -- places the message control in the vertical middle of the window with a 10 pixel left and right border
--HelloWindoww.Button:SetSize(120,20); -- sets the message size
--HelloWindoww.Button:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
--HelloWindoww.Button.Click = function()
	--clearwishlist()
--end -- sets the actual message text
HelloWindoww:SetZOrder(1);
--HelloWindow:SetZOrder(0);

--HelloWindow.SButton=Turbine.UI.Lotro.ScrollBar(); -- create a label control to display our message
--HelloWindow.SButton:SetParent(HelloWindow); -- sets the label as a child of the main window
--HelloWindow.SButton:SetPosition(390,10); -- places the message control in the vertical middle of the window with a 10 pixel left and right border
--HelloWindow.SButton:SetSize(12,500); -- sets the message size
--HelloWindow.SButton:SetOrientation(Turbine.UI.Orientation.Vertical);
--HelloWindow.SButton.ValueChanged=function()
--	HelloWindow.Message:SetPosition(10,40-HelloWindow.SButton:GetValue()*80);

--end

 
--HelloWindow:SetVisible(false);--display the window (windows are not visible by default)  


SmallWindow=Turbine.UI.Window(); -- we call the constructor of the standard window object to create an instance
SmallWindow:SetSize(450,69); -- sets the window size to 200 by 200 pixels
if data["Options"]["chatx"] ~= nil and data["Options"]["chaty"] ~= nil then
	SmallWindow:SetPosition(tonumber(data["Options"]["chatx"]),tonumber(data["Options"]["chaty"])); -- centers the window in the display
else
	SmallWindow:SetPosition(20,Turbine.UI.Display:GetHeight()-200); -- centers the window in the display
end
SmallWindow:SetText("ChatPlus"); -- assigns the title bar text
SmallWindow:SetVisible(true);
SmallWindow:SetBackColor(Turbine.UI.Color(0.5,0,0,0));
SmallWindow:SetWantsKeyEvents(true);
SmallWindow.Button2=Turbine.UI.Button(); -- create a label control to display our message
SmallWindow.Button2:SetParent(SmallWindow); -- sets the label as a child of the main window
SmallWindow.Button2:SetText(""); -- sets the actual message text
SmallWindow.Button2:SetPosition(0,22); -- places the message control in the vertical middle of the window with a 10 pixel left and right border
SmallWindow.Button2:SetSize(25,25); -- sets the message size
SmallWindow.Button2:SetStretchMode(1);
SmallWindow.Button2:SetSize(22,22); -- sets the message size

--SmallWindow.Button2:SetBackColor(Turbine.UI.Color(0.5,0,0,0));

SmallWindow.Button2:SetBackground(0x41101833); 

SmallWindow.Button2.MouseEnter=function()
    SmallWindow.Button2:SetBackground(0x41101832)
end
SmallWindow.Button2.MouseLeave=function()
    SmallWindow.Button2:SetBackground(0x41101833)
end
SmallWindow.Button2.MouseDown=function()
	--SmallWindow.Button2:SetBackground(0x41101833); 

    SmallWindow.Button2:SetBackground(0x41101834)


end
SmallWindow.Button2.MouseUp=function()
	SmallWindow.Button2:SetBackground(0x41101833); 
    --SmallWindow.Button2:SetBackground(0x41101832)
	optionsWindow:SetVisible(true)
	optionsWindow:SetZOrder(100)

end



SmallWindow.Button3=Turbine.UI.Button(); -- create a label control to display our message
SmallWindow.Button3:SetParent(SmallWindow); -- sets the label as a child of the main window
SmallWindow.Button3:SetText(""); -- sets the actual message text
SmallWindow.Button3:SetPosition(0,0); -- places the message control in the vertical middle of the window with a 10 pixel left and right border
SmallWindow.Button3:SetSize(16,16); -- sets the message size
SmallWindow.Button3:SetStretchMode(1);
SmallWindow.Button3:SetSize(22,22); -- sets the message size

SmallWindow.Button3:SetBackground(0x4101e50c); 

SmallWindow.Button3.MouseClick=function()
	startTime=Turbine.Engine.GetLocalTime()
	SmallWindow.Button3:SetWantsUpdates(not SmallWindow.Button3:GetWantsUpdates())
	data["Options"]["chaty"]=tostring(math.ceil(SmallWindow:GetTop()))
	data["Options"]["chatx"]=tostring(math.ceil(SmallWindow:GetLeft()))
	Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);

end
minimised=false
SmallWindow.Button3.MouseDoubleClick=function()
	if SmallWindow:GetHeight() ~= 16 then
		SmallWindow.Button3:SetStretchMode(0);
		SmallWindow.Button2:SetStretchMode(0);
		minimised=true


		SmallWindow:SetSize(16,16)
	elseif data["Options"]["Width"] ~= nil then
		SmallWindow:SetSize(tostring(data["Options"]["Width"]),69)
		SmallWindow.Button3:SetStretchMode(1);
		SmallWindow.Button2:SetStretchMode(1);
		minimised=true

	else
		SmallWindow:SetSize(450,69)
		SmallWindow.Button3:SetStretchMode(1);
		SmallWindow.Button2:SetStretchMode(1);
		minimised=true
	end
end


SmallWindow.Button3.Update=function()
	if minimised then

		SmallWindow.Button3:SetWantsUpdates(false)
		minimised=false
	elseif Turbine.Engine.GetLocalTime()-startTime > 0.2 then
		local x = nil
		local y = nil
		local relx= nil
		local rely =nil
		x,y=SmallWindow:GetPosition()
		relx,rely=SmallWindow:GetMousePosition()

		SmallWindow:SetPosition(x+relx-5,y+rely-5)
	end
end
-------------------------------------------------text entry box-----------------------------------------------------------------------------
SmallWindow.Entry=Turbine.UI.Lotro.TextBox();
SmallWindow.Entry:SetParent(SmallWindow);
SmallWindow.Entry:SetSize(398,22);
SmallWindow.Entry:SetSelectable(true)
SmallWindow.Entry:SetPosition(22,0); --yeah, I got lazy and hardcoded the left side ;)
--SmallWindow.Entry:SetWantsUpdates(true)
SmallWindow.Entry.TextChanged = function(sender,args)
	scUpdate()
end
scUpdate = function()
	local textToSend = SmallWindow.Entry:GetText()
	--Turbine.PluginData.Save(Turbine.DataScope.Character, "aatest", textToSend);
	textToSend=string.gsub(textToSend,"\n"," ")
	if textToSend ~= SmallWindow.Entry:GetText() then
		SmallWindow.Entry:SetText(textToSend)
	end
	for i in pairs(data["Replacements"]) do
		textToSend = string.gsub(textToSend,data["Replacements"][i],i)
		textToSend = string.gsub(textToSend,string.lower(data["Replacements"][i]),i)
		textToSend = string.gsub(textToSend,string.upper(data["Replacements"][i]),i)
		textToSend = string.gsub(textToSend,string.gsub(data["Replacements"][i],"^%l", string.upper),i)
	end



	for i in pairs(data["Names"]) do
		if chosenChannel =="Tell" then
			local firstword=string.gsub(textToSend,"%s.+","")
			textToSend=tostring(string.match(textToSend,"%s(.+)"))
			textToSend = string.gsub(textToSend,i,data["Names"][i])
			textToSend = string.gsub(textToSend,string.lower(i),data["Names"][i])
			textToSend = string.gsub(textToSend,string.upper(i),data["Names"][i])
			textToSend=firstword.." "..textToSend

		else
			textToSend = string.gsub(textToSend,i,data["Names"][i])
			textToSend = string.gsub(textToSend,string.lower(i),data["Names"][i])
			textToSend = string.gsub(textToSend,string.upper(i),data["Names"][i])
		end

	end
	if string.sub(textToSend, 1, 1) ~= "/" and channelsToChat[chosenChannel]==nil then
		SmallWindow.SampleButton4:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"/"..string.gsub(chosenChannel,"%s","").." "..textToSend))
		SmallWindow.SampleButton4.ShortcutData="/"..string.gsub(chosenChannel,"%s","").." "..textToSend
	elseif string.sub(textToSend, 1, 1) ~= "/" and channelsToChat[chosenChannel]~=nil then
		SmallWindow.SampleButton4:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"/"..string.gsub(channelsToChat[chosenChannel],"%s","").." "..textToSend))
		SmallWindow.SampleButton4.ShortcutData="/"..string.gsub(channelsToChat[chosenChannel],"%s","").." "..textToSend

	else
		SmallWindow.SampleButton4:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,textToSend))
		SmallWindow.SampleButton4.ShortcutData=textToSend
	end
end

---------------------------------------------------------------------------Hex Code Entry------------------------------------------
SmallWindow.HexEntryl=Turbine.UI.Label();
SmallWindow.HexEntryl:SetParent(SmallWindow);
SmallWindow.HexEntryl:SetSize(80,22);
SmallWindow.HexEntryl:SetPosition(22,22); --yeah, I got lazy and hardcoded the left side ;)
SmallWindow.HexEntryl:SetWantsUpdates(true);
SmallWindow.HexEntryl:SetMarkupEnabled(true)

SmallWindow.HexEntryl:SetText("Hex Code: #")
SmallWindow.HexEntryl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );

SmallWindow.HexEntry=Turbine.UI.Lotro.TextBox();
SmallWindow.HexEntry:SetParent(SmallWindow);
SmallWindow.HexEntry:SetSize(80,22);
SmallWindow.HexEntry:SetPosition(102,22); --yeah, I got lazy and hardcoded the left side ;)
--SmallWindow.HexEntry:SetWantsUpdates(true);

SmallWindow.HexEntry.TextChanged = function(sender,args)
	SmallWindow.HexEntry:SetText(string.gsub(SmallWindow.HexEntry:GetText(),"%X",""))
	if string.gsub(SmallWindow.HexEntry:GetText(),"%X","")~= "" then
		SmallWindow.HexEntryl:SetText("<rgb=0x"..string.gsub(SmallWindow.HexEntry:GetText(),"%X","")..">"..strings["Hex Code:"][lang].." </rgb> #")
	else
		SmallWindow.HexEntryl:SetText("Hex Code: #")
	end

end

----------------------------------------------------------------------------Set Colour Button------------------------------------------
SmallWindow.HexSend=Turbine.UI.Button();
SmallWindow.HexSend:SetParent(SmallWindow);
SmallWindow.HexSend:SetSize(50,18);
SmallWindow.HexSend:SetPosition(184,24);
SmallWindow.HexSend:SetText(strings["Colour"][lang]);
SmallWindow.HexSend:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5,0.5));
SmallWindow.HexSend.MouseEnter=function()
	SmallWindow.HexSend:SetBackColor(Turbine.UI.Color(0.5,0.2,0.2,0.7));
	entrystartpos=SmallWindow.Entry:GetSelectionStart()
	entryendpos = entrystartpos+SmallWindow.Entry:GetSelectionLength()

end
SmallWindow.HexSend.MouseDown=function()
	SmallWindow.HexSend:SetBackColor(Turbine.UI.Color(0.5,0.1,0.1,0.9));
end
SmallWindow.HexSend.MouseUp=function()
	SmallWindow.HexSend:SetBackColor(Turbine.UI.Color(0.5,0.2,0.2,0.7));
end
SmallWindow.HexSend.MouseLeave=function()
	SmallWindow.HexSend:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5,0.5));
end
SmallWindow.HexSend.MouseClick=function()
	local start =entrystartpos
	local endpos=entryendpos
	if endpos-start ~= 0 then

		SmallWindow.Entry:SetText(string.sub(SmallWindow.Entry:GetText(),1,start-1).."<rgb=0x"..SmallWindow.HexEntry:GetText()..">"..string.sub(SmallWindow.Entry:GetText(),start,endpos-1).."</rgb>"..string.sub(SmallWindow.Entry:GetText(),endpos))
		scUpdate()
	end
end

---------------------------------------------------------------------set underline button-----------------------------------------

SmallWindow.USend=Turbine.UI.Button();
SmallWindow.USend:SetParent(SmallWindow);
SmallWindow.USend:SetSize(30,18);
SmallWindow.USend:SetPosition(236,24);
SmallWindow.USend:SetMarkupEnabled(true);
SmallWindow.USend:SetText("<u>U</u>");
SmallWindow.USend:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5,0.5));
SmallWindow.USend.MouseEnter=function()
	SmallWindow.USend:SetBackColor(Turbine.UI.Color(0.5,0.2,0.2,0.7));
	entrystartpos=SmallWindow.Entry:GetSelectionStart()
	entryendpos = entrystartpos+SmallWindow.Entry:GetSelectionLength()

end
SmallWindow.USend.MouseDown=function()
	SmallWindow.USend:SetBackColor(Turbine.UI.Color(0.5,0.1,0.1,0.9));
end
SmallWindow.USend.MouseUp=function()
	SmallWindow.USend:SetBackColor(Turbine.UI.Color(0.5,0.2,0.2,0.7));
end
SmallWindow.USend.MouseLeave=function()
	SmallWindow.USend:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5,0.5));
end
SmallWindow.USend.MouseClick=function()
	local start =entrystartpos
	local endpos=entryendpos
	if endpos-start ~= 0 then
		SmallWindow.Entry:SetText(string.sub(SmallWindow.Entry:GetText(),1,start-1).."<u>"..string.sub(SmallWindow.Entry:GetText(),start,endpos-1).."</u>"..string.sub(SmallWindow.Entry:GetText(),endpos))
		scUpdate()
	end
end






------------------------------------------------------------Send quicklost button, thanks garan! -----------------------------
SmallWindow.SampleButton4=Turbine.UI.Lotro.Quickslot();
SmallWindow.SampleButton4:SetParent(SmallWindow);
SmallWindow.SampleButton4:SetSize(26,22);
SmallWindow.SampleButton4:SetPosition(420,0); --yeah, I got lazy and hardcoded the left side ;)
SmallWindow.SampleButton4:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"/say"))
SmallWindow.SampleButton4.ShortcutData="/say"; --save the alias text for later
SmallWindow.SampleButton4:SetAllowDrop(false); -- turn off drag and drop so the user doesn't accidentally modify our button action
SmallWindow.SampleButton4.DragDrop=function()
    -- even though we turned off drop operations, there is a bug that allows the quickslot to drop on itself effectively wiping out the shortcut
    local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
    sc:SetData(SmallWindow.SampleButton4.ShortcutData);
    SmallWindow.SampleButton4:SetShortcut(sc);
end
SmallWindow.SampleButton4.Backdrop=Turbine.UI.Control(); -- note, if the icon has no transparencies then this backdrop is not needed
SmallWindow.SampleButton4.Backdrop:SetParent(SmallWindow);
SmallWindow.SampleButton4.Backdrop:SetSize(26,22);
SmallWindow.SampleButton4.Backdrop:SetPosition(420,0); --yeah, I got lazy and hardcoded the left side ;)
SmallWindow.SampleButton4.Backdrop:SetZOrder(SmallWindow.SampleButton4:GetZOrder()+1); -- force the icon to be displayed above the quickslot
SmallWindow.SampleButton4.Backdrop:SetBackColor(Turbine.UI.Color(1,0,0,0));
SmallWindow.SampleButton4.Backdrop:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
SmallWindow.SampleButton4.Icon=Turbine.UI.Control();
SmallWindow.SampleButton4.Icon:SetParent(SmallWindow);
SmallWindow.SampleButton4.Icon:SetSize(26,22);
SmallWindow.SampleButton4.Icon:SetPosition(420,0); --yeah, I got lazy and hardcoded the left side ;)
SmallWindow.SampleButton4.Icon:SetZOrder(SmallWindow.SampleButton4:GetZOrder()+2); -- force the icon to be displayed above the quickslot
SmallWindow.SampleButton4.Icon:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
SmallWindow.SampleButton4.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay); -- this will cause any transparent parts of the background image to display your window's background instead of being completely transparent and displaying the game UI display

-- this is the code that handles the background, note that the handles are assigned to the quickslot but they manipulate the icon
SmallWindow.SampleButton4.Icon:SetBackground(0x4110aed6)
SmallWindow.SampleButton4.MouseEnter=function()
    SmallWindow.SampleButton4.Icon:SetBackground(0x4110aed7)
end
SmallWindow.SampleButton4.MouseLeave=function()
	SmallWindow.SampleButton4.Icon:SetBackground(0x4110aed6)
	scUpdate()

end
SmallWindow.SampleButton4.MouseDown=function()
	SmallWindow.SampleButton4.Icon:SetBackground(0x4110aed8)
	
	
end
SmallWindow.SampleButton4.MouseUp=function()
	SmallWindow.SampleButton4.Icon:SetBackground(0x4110aed7)
	SmallWindow.Entry:SetText("")
end



---------------------------------------Channels list---------------------------------------------------------

SmallWindow.ChanListBox=Turbine.UI.ListBox()
SmallWindow.ChanListBox:SetParent(SmallWindow)
SmallWindow.ChanListBox:SetBackColor(Turbine.UI.Color(0.2,0.2,0.2))
SmallWindow.ChanListBox:SetPosition(0,44)
SmallWindow.ChanListBox:SetSize(500,500)
SmallWindow.ChanListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
populateList = function()
	local counter = 1
	for i in pairs(mainChannels) do
		local listItem = Turbine.UI.Button()
		local item = Turbine.UI.Control()

		--print(i)
		listItem:SetText(tostring(i));
		listItem:SetFont(Verdana10)
		listItem:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		listItem:SetSize(((SmallWindow:GetWidth()+2)/mainChannelsN)-2, 25 );
		if mainChannels[i] == true then
			listItem:SetBackColor(Turbine.UI.Color(0.5,0.2,0.2,0.8));
			listItem.MouseLeave=function()
				listItem:SetBackColor(Turbine.UI.Color(0.5,0.2,0.2,0.8));
			end

		else
			listItem:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5,0.5));
			listItem.MouseLeave=function()
				listItem:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5,0.5));
			end

	
			--listItem:SetBackground(imageCodes[counter]);
			--listItem:SetSize(284,90)
			--listItem:SetStretchMode(1)
			--listItem:SetSize(((SmallWindow:GetWidth()+2)/mainChannelsN)-2, 25 );
		listItem.MouseEnter=function()
			listItem:SetBackColor(Turbine.UI.Color(0.5,0.2,0.2,0.5));
		end
		listItem.MouseDown=function()
			listItem:SetBackColor(Turbine.UI.Color(0.5,0.1,0.1,0.9));
		end
		listItem.MouseUp=function()
			listItem:SetBackColor(Turbine.UI.Color(0.5,0.2,0.2,0.7));
		end


	
		end
		--loadstring(listItem.string.gsub(i,%s,""):SetSize(((SmallWindow:GetWidth()+2)/mainChannelsN)-2, 25 ));
		counter=counter+1
		listItem.index=i
	
	
		SmallWindow.ChanListBox:AddItem(listItem);
		item= Turbine.UI.Control();
	
		item:SetSize(2, 25 );
		item:SetBackColor(Turbine.UI.Color(0.8,0.2,0.2,0.2));
		SmallWindow.ChanListBox:AddItem( item );
	
	end
end
populateList()
function SmallWindow.ChanListBox:SelectedIndexChanged(sender, args)
	chosenChannel = SmallWindow.ChanListBox:GetSelectedItem()["index"] 
	for i in pairs(mainChannels) do
		mainChannels[i] = (chosenChannel == i)
	end
	SmallWindow.ChanListBox:ClearItems()
	populateList()
	scUpdate()
end
---------------------------------------------------------------

--/kinship /officer test

-------------------------------------------------Dealing with visiblity of windows
SmallWindow.KeyDown = function(sender,args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		vis=true;
	elseif ( args.Action == 268435635 ) then
		vis= not vis;


	end
	if vis then
		SmallWindow:SetVisible(true);
	else
		SmallWindow:SetVisible(false);
	end
end

--------------------------flashing notification
 
wlmsg=""

flash = function()
	HelloWindoww:SetWantsUpdates(true)
	startTime=Turbine.Engine.GetLocalTime()
	--print(startTime)
end

HelloWindoww.Update = function()
	elapsed=(math.floor(Turbine.Engine.GetLocalTime()-startTime))%8
	if elapsed >5 then
		--vis = false
		HelloWindoww:SetVisible(false)
		HelloWindoww:SetWantsUpdates(false)
	elseif elapsed %2 == 0 then
		--vis=false
		HelloWindoww:SetVisible(false)
	else
		--vis = true
		HelloWindoww:SetVisible(true)
	end
end

--------------------------------------------commands-------------------------------------------------

HelloWindoww.shellCommand=Turbine.ShellCommand();
HelloWindoww.shellCommand.Execute = function(sender, cmd, args)
	local command=args
	print("/ChatPlus "..command)
	command=string.gsub(command,"\n","")

	local to =nil
	local from = nil
	if string.match(command,"(%w+).+")=="rename" then
		command=string.gsub(command,"rename%s","",1)
		from = string.gsub(command,"%sto.+","")
		command = string.gsub(command,".+%sto%s","")
		if string.match(command,"(%w+).-")=="random"   then
			command=string.gsub(command,"random%s?","")
			to=randomName({["race"]=tostring(string.match(command,"race=(%a+)%s?")),["origin"]=tostring(string.match(command,"origin=(%a+)%s?")),["gender"]=tostring(string.match(command,"gender=(%a+)%s?"))})
		else
			to=command
		end
		data["Replacements"][string.lower(from)]=to
		Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
		Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus is renaming"][lang].." </rgb><rgb=0xFF8B00>"..from.."</rgb><rgb=0x00FFE6> "..strings["to"][lang]..  " </rgb><rgb=0xFF8B00>"..to.."</rgb>")
	
	elseif string.lower(string.match(command,"(%w+).+"))=="minimumletters" then
		command=string.lower(command)
		command=string.gsub(command,"minimumletters%s?","",1)
		data["Options"]["minimumLetters"]=tostring(command)
		command=tonumber(command)
		for i in pairs(data["Replacements"]) do
			if inDict(i)==false and string.find(i,command) ~= nil then
				data["Replacements"][i]=string.gsub(i,"^%l", string.upper)
				Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus is returning"][lang].." </rgb><rgb=0xFF8B00>"..string.gsub(i,"^%l", string.upper).."</rgb><rgb=0x00FFE6> "..strings["to their original name"][lang].." </rgb>")
			end
			if inDict(i)==true and string.find(i,command) ~= nil then
				data["Replacements"][i]=randomName({})
				Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus is renaming"][lang].." </rgb><rgb=0xFF8B00>"..i.."</rgb><rgb=0x00FFE6> "..strings["to"][lang].." </rgb><rgb=0xFF8B00>"..data["Replacements"][i].."</rgb>")

			end

		end
		Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
		Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus has set the minimum letters in order to automatically rename to"][lang].." </rgb><rgb=0xFFFFFF>"..tostring(command).."</rgb>")
	elseif string.lower(string.match(command,"(%w+).+"))=="customcolors" or string.lower(string.match(command,"(%w+).+"))=="customcolours" then
		command=string.lower(command)
		command=string.gsub(command,"customcolors%s?","",1)
		command=string.gsub(command,"customcolours%s?","",1)


		if command =="off" then
			data["Options"]["customColours"]=true
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus is now filtering custom chat colours"][lang].."</rgb>")
		elseif command == "on" then
			data["Options"]["customColours"]=false
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus has stopped filtering custom chat colours"][lang].."</rgb>")
		end
		Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);


	elseif string.lower(string.match(command,"(%w+).-"))=="off" then
		off=true
		Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus is now off"][lang].."</rgb>")
	elseif string.lower(string.match(command,"(%w+).-"))=="on" then
		off=false
		Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus is now on"][lang].."</rgb>")

	elseif string.lower(string.match(command,"(%w+).+"))=="autorenaming" then
		command=string.lower(command)
		command=string.gsub(command,"autorenaming%s?","",1)

		if command =="on" then
			data["Options"]["autoRenaming"]=true
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus is now automatically renaming characters that may not fit with lore"][lang].."</rgb>")
		elseif command == "off" then
			data["Options"]["autoRenaming"]=false
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus has stopped automatically renaming characters that may not fit with lore"][lang].."</rgb>")
		end
		Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);

	elseif string.lower(string.match(command,"(%w+).+"))=="channelcolor" or string.lower(string.match(command,"(%w+).+"))=="channelcolour" then
		command=string.lower(command)
		command=string.gsub(command,"channelcolour%s?","",1)
		command=string.gsub(command,"channelcolor%s?","",1)
		local channel = string.gsub(command,"%s.+","")
		--print(channel)
		local colour = string.gsub(command,channel.."%s","")
		--print(colour)
		local channelno = nil

		for i in pairs(chatCodes) do
			--print(string.lower(chatCodes[i]))
			if channel == string.lower(chatCodes[i]) then
				channelno = i
			end
		end
		print(channelno)
		local recog=false
		for i in pairs(colourCodes) do
			if colour==string.lower(i) then
				colour=i
				recog=true
			end
		end
		--print(colour)
		colour=string.gsub(colour,"\#","")
		if not recog then
			colour=string.upper(colour)
		end
		if colourCodes[colour] ~= nil or string.gsub(colour,"%x%x%x%x%x%x","") == "" then
			data["Colours"][channelno]["1"]=colour
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus changed the colour of"][lang].." </rgb><rgb=0xFFFFFF>"..channel.."</rgb><rgb=0x00FFE6> "..strings["to"][lang].." </rgb><rgb=0xFFFFFF>"..colour.."</rgb>")
		else
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus does not recognise the colour"][lang].." </rgb><rgb=0xFFFFFF>"..colour.."</rgb>")

		end
		Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
		--Turbine.Shell.WriteLine("<rgb=0x00FFE6>ChatPlus changed the colour of </rgb><rgb=0xFFFFFF>"..channel.."</rgb><rgb=0x00FFE6> to </rgb><rgb=0xFFFFFF>"..colour.."</rgb>")



	elseif string.lower(string.match(command,"(%w+).+"))=="channeltoggle" then
		command=string.lower(command)
		command=string.gsub(command,"channeltoggle%s?","",1)
		local channel = string.gsub(command,"%s.+","")
		local toggle = string.gsub(command,".+%s","")
		local channelno = nil
		for i in pairs(chatCodes) do
			if channel == string.lower(chatCodes[i]) then
				channelno = i
				--print(channelno)
			end
		end
		if toggle == "on" and channelno ~= nil then
			data["Colours"][channelno]["2"]=true
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus turned"][lang].." </rgb><rgb=0xFFFFFF>"..channel.."</rgb><rgb=0x00FFE6> "..strings["on"][lang].."</rgb>")
		elseif toggle == "off" and channelno ~= nil then
			data["Colours"][channelno]["2"]=false
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus turned"][lang].." </rgb><rgb=0xFFFFFF>"..channel.."</rgb><rgb=0x00FFE6> "..strings["off"][lang].."</rgb>")

		else
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus does not recognise the toggle value"][lang].."</rgb>")
		end

		Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);





		

		

	elseif string.match(command,"(%w+).+")=="view" then
		local hits = false
		local list =""
		command=string.gsub(command,"view%s","",1)
		for i in pairs(data["Replacements"]) do
			if command == "all" or string.lower(command) == i or data["Replacements"][i] == command then
				list=list.."\n".."<rgb=0xFF8B00>"..string.gsub(i,"^%l",string.upper).."</rgb><rgb=0x00FFE6> "..strings["to"][lang].." </rgb><rgb=0xFF8B00>"..data["Replacements"][i]
				hits=true
			end
		end
		if hits then
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus has renamed:"][lang].."</rgb>"..list)
		else
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus not found anyone with name"][lang].." </rgb><rgb=0xFF8B00>"..command.."</rgb>")
		end


			
			

	elseif string.match(command,"(%w+).+")=="allow" then
		command=string.lower(command)
		command=string.gsub(command,"allow%s","",1)
		data["Allowed"][command]=true

		for i in pairs(data["Replacements"]) do
			if inDict(i)==false and string.find(i,command) ~= nil then
				data["Replacements"][i]=string.gsub(i,"^%l", string.upper)
				Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus is returning"][lang].." </rgb><rgb=0xFF8B00>"..string.gsub(i,"^%l", string.upper).."</rgb><rgb=0x00FFE6> "..strings["to their original name"][lang].." </rgb>")
			end
		end
		Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
			
	elseif string.match(command,"(%w+).+")=="ban"  then
		command=string.lower(command)
		command=string.gsub(command,"ban%s","",1)
		data["Allowed"][command]=false

		for i in pairs(data["Replacements"]) do
			if inDict(i)==true and string.find(i,command) ~= nil then
				data["Replacements"][i]=randomName({})
				Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus is renaming"][lang].." </rgb><rgb=0xFF8B00> "..i.."</rgb><rgb=0x00FFE6> "..strings["to"][lang].." </rgb><rgb=0xFF8B00>"..data["Replacements"][i].."</rgb>")

			end
		end
		Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
		Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus will start renaming people with names containing"][lang].." </rgb><rgb=0xFF8B00>"..command.."</rgb>")
	
	elseif string.lower(string.match(command,"(%w+).-"))=="viewcodes"  then
		for i in pairs(data["Names"	]) do
			print(data["Names"][i]..": "..string.gsub(string.gsub(data["Names"][i],'<','\\<'),'>','\\>'))
		end

	elseif string.lower(string.match(command,"(%w+).+"))=="wishlist"  then
		command=string.lower(command)
		command=string.gsub(command,"wishlist%s","",1)
		if string.lower(string.match(command,"(%w+)%s+"))=="add"  then
			--print("f")
			command=string.gsub(command,"add%s+","",1)
			data["WishList"][command]=true
			print("<rgb=0x00FFE6>"..strings["adding"][lang].." </rgb><rgb=0xFFFFFF>"..command.." <rgb=0x00FFE6>"..strings["to"][lang].." "..strings["wishlist"][lang].."</rgb>")
		elseif string.lower(string.match(command,"(%w+)%s+"))=="remove"  then
			command=string.gsub(command,"remove%s+","",1)
			data["WishList"][command]=nil
			print("<rgb=0x00FFE6>"..strings["removing"][lang].." </rgb><rgb=0xFFFFFF>"..command.." <rgb=0x00FFE6>"..strings["from"][lang].." "..strings["wishlist"][lang].."</rgb>")

		else
			print(strings["Unknown ChatPlus command. Please view command list in plugin manager"][lang])
		end
		Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);

	elseif string.lower(string.match(command,"(%w+).-"))=="viewwishlist"  then
		for i in pairs(data["WishList"]) do
			if data["WishList"][i]==true then
				print("<rgb=0xFFFFFF>"..i.."</rgb>")
			end
		end

	elseif string.lower(string.match(command,"(%w+).+"))=="reset"  then
		command=string.lower(command)
		command=string.gsub(command,"reset%s","",1)
		command=string.gsub(command,"^%l", string.upper)
		Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusDataBackup", data);

		if command=="All" then
			data=defaultData
			print("<rgb=0x00FFE6>"..strings["resetting"][lang].." </rgb><rgb=0xFFFFFF>"..command.."</rgb>")		

		elseif data[command] ~= nil then
			data[command]=defaultData[command]
			print("<rgb=0x00FFE6>"..strings["resetting"][lang].." </rgb><rgb=0xFFFFFF>"..command.."</rgb>")	
		else
			print("<rgb=0x00FFE6>"..strings["noreset"][lang].." </rgb><rgb=0xFFFFFF>"..command.."</rgb>")	
		end	
		Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);


	elseif string.lower(string.match(command,"(%w+).+"))=="devmode"  then
		command=string.lower(command)
		command=string.gsub(command,"devmode%s","",1)
		if command == "on" then
			data["Options"]["DevMode"]=true
			print("<rgb=0x00FFE6>"..strings["dmo"][lang].." </rgb>")
		else
			data["Options"]["DevMode"]=false
			print("<rgb=0x00FFE6>"..strings["dmoff"][lang].." </rgb>")

		end
		Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);


			



	elseif string.lower(string.match(command,"(%w+).-"))=="help"  then
		print("<rgb=0x00FFE6>"..strings["help"][lang].." </rgb>")



	else
		Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Unknown ChatPlus command. Please view command list by typing /ChatPlus help"][lang]..".</rgb>")
	end

end
HelloWindoww.tellCommand=Turbine.ShellCommand();
HelloWindoww.tellCommand.Execute = function(sender, cmd, args)
	local command=args
	for i in pairs(data["Replacements"]) do
		if string.lower(i) ~= string.lower(data["Replacements"][i]) then
			command=string.gsub(command,"\("..string.lower(data["Replacements"][i]).."\)",i)
			command=string.gsub(command,"\("..data["Replacements"][i].."\)",i)
		end
	end
end

Turbine.Shell.AddCommand("ChatPlus",HelloWindoww.shellCommand);
Turbine.Shell.AddCommand("atell",HelloWindoww.tellCommand);

	
----------------------------------------------------chat monitor---------------------------------------------------------------

 -- define the AddCallback function
function AddCallback(object, event, callback)
	if (object[event] == nil) then
		object[event] = callback;
	elseif (type(object[event]) == "table") then
		table.insert(object[event], callback);
	else
		object[event] = {object[event], callback};
	end
	return callback;
end


	


ChatMonitor = Turbine.Chat
ChatReceived = function(f, args)
	local disp =true
	local msg = args.Message;
	--print(msg);
	local senderxml = nil
	local col = nil
	local sender = nil
	--print(tostring(args.Sendera))
	if data["Notifications"][tostring(args.ChatType)]  == nil then
		data["Notifications"][tostring(args.ChatType)]	 = {}
	end

	for i in pairs(data["Notifications"][tostring(args.ChatType)]) do
		--print(i)
		if string.find(string.lower(msg),string.lower(i)) ~= nil and data["Notifications"][tostring(args.ChatType)][i] == true then
			wlmsg=string.gsub(msg,"<.->","")
			vis=true
			HelloWindoww.Message:SetText(wlmsg);
			HelloWindoww.Message:SetMouseVisible(false);

			HelloWindoww:SetVisible(true);
			flash();
		end
	end
	if data["Filters"]  == nil then
		data["Filters"] = {}
	end

	for i in pairs(data["Filters"]) do
		--print(i)
		if string.find(string.lower(msg),string.lower(i)) ~= nil then
			disp=false
		end
	end

			
	if(args.ChatType ~= 4 and off ~= true and disp==true and args.ChatType ~= 6 and data["Colours"][tostring(args.ChatType)]["2"] and args.ChatType ~= 25) and msg ~= nil then -- checks that channel can be filtered out and sees if user has hidden channel
		--Turbine.Shell.WriteLine(args.Sender)
		--msg=string.gsub(msg,'<','(')
		--msg=string.gsub(msg,'>',')')
		--Turbine.Shell.WriteLine(msg)
		--Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusSend", sender)
		sender=string.match(msg,">(%a+)<\\Select>.-")
		if string.match(msg,"<(.+)<\\Select>") ~= nil then
			--print("match");
			senderxml="<"..string.match(msg,"<(.+)<\\Select>").."<\\Select>";
		end
		--print(tostring(data["Names"][sender]))
		--print(tostring(senderxml))
		--print(tostring(sender))
		if data["Names"][sender] == nil and senderxml ~= nil and sender ~= nil then
			data["Names"][sender]=senderxml
			Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
		end
		--Turbine.Shell.WriteLine(sender)
		if data["Options"]["autoRenaming"] ~= false then
			if inDict(sender) and sender ~= args.Sender and data["Options"]["autoRenaming"] ~= false and sender~=nil and off ~= true then
				if data["Replacements"][string.lower(sender)] == nil then
					data["Replacements"][string.lower(sender)]=randomName({})
					Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["ChatPlus is renaming"][lang].." </rgb><rgb=0xFF8B00>"..sender.."</rgb><rgb=0x00FFE6> "..strings["to"][lang].." </rgb><rgb=0xFF8B00>"..data["Replacements"][string.lower(sender)].."</rgb>")
					replacements()
					Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);

				end
			end
		end
		if colourCodes[data["Colours"][tostring(args.ChatType)]["1"]]	~=nil then
			col=colourCodes[data["Colours"][tostring(args.ChatType)]["1"]]
		else
			col=data["Colours"][tostring(args.ChatType)]["1"]	
		end	
		if string.find(msg,"ExamineItemInstance%:ItemInfo") == nil then
			for i in pairs(data["Names"]) do
				msg=string.gsub(msg,"%s+"..i.."%s+",' '..data["Names"][i]..' ')
				msg=string.gsub(msg,i.."%s+",data["Names"][i]..' ')
				msg=string.gsub(msg,i.."%\n",data["Names"][i])
				msg=string.gsub(msg,i.."%,",data["Names"][i]..',')
				msg=string.gsub(msg,i.."%.",data["Names"][i]..'.')
				msg=string.gsub(msg,i.."%?",data["Names"][i]..'?')
				msg=string.gsub(msg,i.."%!",data["Names"][i]..'!')
				msg=string.gsub(msg,string.lower("%s+"..i.."%s+"),string.lower(' '..data["Names"][i]..' '))
				msg=string.gsub(msg,string.lower(i.."%s+"),string.lower(data["Names"][i]..' '))
				msg=string.gsub(msg,string.lower(i.."%\n"),string.lower(data["Names"][i]))
				msg=string.gsub(msg,string.lower(i.."%,"),string.lower(data["Names"][i]..','))
				msg=string.gsub(msg,string.lower(i.."%."),string.lower(data["Names"][i]..'.'))
				msg=string.gsub(msg,string.lower(i.."%?"),string.lower(data["Names"][i]..'?'))
				msg=string.gsub(msg,string.lower(i.."%!"),string.lower(data["Names"][i]..'!'))
				msg=string.gsub(msg,string.upper("%s+"..i.."%s+"),string.upper(' '..data["Names"][i]..' '))
				msg=string.gsub(msg,string.upper(i.."%s+"),string.upper(data["Names"][i]..' '))
				msg=string.gsub(msg,string.upper(i.."%\n"),string.upper(data["Names"][i]))
				msg=string.gsub(msg,string.upper(i.."%,"),string.upper(data["Names"][i]..','))
				msg=string.gsub(msg,string.upper(i.."%."),string.upper(data["Names"][i]..'.'))
				msg=string.gsub(msg,string.upper(i.."%?"),string.upper(data["Names"][i]..'?'))
				msg=string.gsub(msg,string.upper(i.."%!"),string.upper(data["Names"][i]..'!'))

			end
		end
		for i in pairs(data["Replacements"]) do
			if data["Names"][i] ~= nil then
				msg=string.gsub(msg,"%s+"..data["Replacements"][i].."%s+",' '..data["Names"][i]..' ')
				msg=string.gsub(msg,data["Replacements"][i].."%s+",data["Names"][i]..' ')
				msg=string.gsub(msg,data["Replacements"][i].."%\n",data["Names"][i])
				msg=string.gsub(msg,data["Replacements"][i].."%,",data["Names"][i]..',')
				msg=string.gsub(msg,data["Replacements"][i].."%.",data["Names"][i]..'.')
				msg=string.gsub(msg,data["Replacements"][i].."%?",data["Names"][i]..'?')
				msg=string.gsub(msg,data["Replacements"][i].."%!",data["Names"][i]..'!')
				msg=string.gsub(msg,string.lower("%s+"..data["Replacements"][i].."%s+"),string.lower(' '..data["Names"][i]..' '))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%s+"),string.lower(data["Names"][i]..' '))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%\n"),string.lower(data["Names"][i]))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%,"),string.lower(data["Names"][i]..','))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%."),string.lower(data["Names"][i]..'.'))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%?"),string.lower(data["Names"][i]..'?'))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%!"),string.lower(data["Names"][i]..'!'))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%s+"),string.lower(data["Names"][i]..' '))
				msg=string.gsub(msg,string.upper("%s+"..data["Replacements"][i].."%s+"),string.upper(' '..data["Names"][i]..' '))
				msg=string.gsub(msg,string.upper(data["Replacements"][i].."%\n"),string.upper(data["Names"][i]))
				msg=string.gsub(msg,string.upper(data["Replacements"][i].."%,"),string.upper(data["Names"][i]..','))
				msg=string.gsub(msg,string.upper(data["Replacements"][i].."%."),string.upper(data["Names"][i]..'.'))
				msg=string.gsub(msg,string.upper(data["Replacements"][i].."%?"),string.upper(data["Names"][i]..'?'))
				msg=string.gsub(msg,string.upper(data["Replacements"][i].."%!"),string.upper(data["Names"][i]..'!'))

			end
		end
		msg=string.gsub(msg,'\n','')

		for i in pairs(data["Replacements"]) do
			if string.lower(i) ~= string.lower(data["Replacements"][i]) then
				msg=string.gsub(msg,string.gsub(i,"^%l", string.upper),'('..data["Replacements"][i]..')')
				msg=string.gsub(msg,string.lower(i),string.lower('('..data["Replacements"][i]..')'))
				msg=string.gsub(msg,string.upper(i),string.upper('('..data["Replacements"][i]..')'))
			end
		end
		--msg=string.gsub(msg,'<','(')
		--msg=string.gsub(msg,'>',')')
		--Turbine.Shell.WriteLine(msg)
		if data["Options"]["customColours"] ==true then
			msg=string.gsub(msg,"<.?rgb.->","")
		end
		if data["Options"]["customUnderlines"] ==true then
			msg=string.gsub(msg,"<.?u>","")
		end

		if data["Options"]["DevMode"]==true then
			msg = string.gsub(string.gsub(msg,"<","("),">",")")
		end
	if off ~= true then
		Turbine.Shell.WriteLine('<rgb='..col..'>'..msg..'</rgb>');
	end
end
end



AddCallback(Turbine.Chat, "Received", ChatReceived)

